program benzine(input, output);

{
  strategie: noteer in  kosten[s,w] voor elke stad s,
  en voor elke w (0 <= w <= MAXTANK) wat het minimaal kost om van
  de beginstad in stad s te komen met w liters in de tank.
}

const 
   INVOER   = 'benzine.in';
   ONEINDIG = MAXINT;
   ONEINDIGER = MAXLONGINT;
   MAXTANK  = 60;
  type 
    stadt = 'A'..'Z';
    tank  = 0..MAXTANK;

  var
    start, eind    : stadt;   
    afstand        : array[stadt, stadt] of integer;
    benzineprijs   : array[stadt] of integer;
    tobedone       : array[stadt] of boolean; 
    kosten         : array[stadt,tank] of longint;


procedure dumpkosten;
  var stad: stadt;
    liters: TANK;
  begin
    writeln('--------dumpkosten---------');
    for stad := 'A' to 'Z' do
      if benzineprijs[stad] < ONEINDIG then
      begin
        write(stad: 2);
        for liters := 0 to MAXTANK do
          write (kosten[stad, liters] : 5);
        writeln;
      end;
    end;  

procedure dump;
   var  
     aantalsteden: integer;
     stadno: integer;
     aantalburen: integer;
     buurno: integer;
     dezestad, buur: stadt;
     prijs: integer;
     dist: integer;
begin
  writeln('--------dump---------');
  for dezestad := 'A' to 'Z' do
    if benzineprijs[dezestad] < ONEINDIG then
    begin
      write(dezestad: 2);
      writeln(benzineprijs[dezestad]:5);
      for buur := 'A' to 'Z' do
        if afstand[dezestad, buur] < ONEINDIG then
           write(buur:2, afstand [dezestad, buur]:5);
      writeln;
    end;  
    writeln(start: 2, eind: 2);
end;


procedure initall;
  var 
    stad, stad2 : stadt;
    liters: tank;
  begin
    for stad := 'A' to 'Z' do
      for stad2 := 'A' to 'Z' do
        afstand[stad, stad2] := ONEINDIG;
    for stad := 'A' to 'Z' do
      tobedone[stad] := false;
    for stad := 'A' to 'Z' do
      benzineprijs[stad] := ONEINDIG;
    for stad := 'A' to 'Z' do
      for liters := 0 to MAXTANK do
        kosten[stad, liters] := ONEINDIGER;
  end;
       
procedure readcase(var infile: text);
  var  
     aantalsteden: integer;
     stadno: integer;
     aantalburen: integer;
     buurno: integer;
     dezestad, buur: stadt;
     prijs: integer;
     dist: integer;
  begin
    readln(infile, aantalsteden);
    for stadno := 1 to aantalsteden do
    begin
      readln(infile, dezestad, prijs, aantalburen);
      benzineprijs[dezestad] := prijs;
      for buurno := 1 to aantalburen do
      begin
        readln(infile, buur, dist);
        if dist <= MAXTANK then
          afstand[dezestad, buur] := dist;
      end;
    end;
    read(infile, start, eind);    
  end; 

procedure update(deze, buur: stadt);
  var 
    changed: boolean;
    liters :tank; 
    d : integer;
  begin 
    changed := false;
    d := afstand[deze, buur];
    for liters := 0 to MAXTANK - d do 
      if kosten[buur, liters] > kosten[deze, liters + d] then
       begin
         kosten[buur, liters] := kosten[deze, liters + d];
         changed := true;   
       end;
    if changed then 
       for liters := 0 to MAXTANK - 1 do
         if kosten[buur, liters+1] > kosten[buur, liters] + benzineprijs[buur] then
            kosten[buur, liters+1] := kosten[buur, liters] + benzineprijs[buur];
    if changed and (kosten[buur, 0] < kosten[eind, 0]) then
       tobedone[buur] := true; 
  end;

procedure process;
  var liters: integer;
      klaar : boolean;
      dezestad, buur: stadt;
  begin
    for liters := 0 to MAXTANK do
       kosten[start, liters] := liters * benzineprijs[start];
    tobedone[start] := true;  
    klaar := false; 
    while not klaar do
    begin
      klaar := true;
      for dezestad := 'A' to 'Z' do
        if tobedone[dezestad] then
        begin
          for buur := 'A' to 'Z' do
            if afstand[dezestad, buur] < ONEINDIG then
              update(dezestad, buur); 
          tobedone[dezestad] := false; 
          klaar := false;  
        end;
    end;
  end;

procedure writeanswer;
  begin
    if kosten[eind, 0] < ONEINDIGER then
        writeln(kosten[eind, 0] )
    else
       writeln('ONMOGELIJK');   
  end;

procedure main;
  var 
    infile : text;
    aantal : integer; 
    caseno : integer;  
  begin
    { writeln('-- tankenP --'); }
    assign(infile,INVOER);  
    reset(infile);
    readln(infile, aantal);
    for caseno := 1 to aantal do
    begin
      initall;
      readcase(infile);
      process;
      writeanswer;
    end;
    close(infile);  
  end;

begin 
  main;
end.

