/*
 * convex.java
 * Joris van Rantwijk, Okt 1999
 * TU Delft
 */

import java.io.*;

public class convex
{

	static StreamTokenizer fin;

	static int[] xcoord;
	static int[] ycoord;
	static int n;

	static void readinp() throws IOException
	{
		int i;

		fin.nextToken();
		n = Integer.parseInt(fin.sval);

		if (n < 4 || n > 100)
			System.err.println("Bogus input at line " +
			                   fin.lineno() + ": n = " + n);

		xcoord = new int[n];
		ycoord = new int[n];

		for (i = 0; i < n; i++) {
			fin.nextToken();
			xcoord[i] = Integer.parseInt(fin.sval);
			fin.nextToken();
			ycoord[i] = Integer.parseInt(fin.sval);
		}
	}

	static int triangle(int a, int b, int c)
	{
		int area;
		area = (xcoord[c] - xcoord[b]) * (ycoord[a] - ycoord[b]) +
		       (ycoord[c] - ycoord[b]) * (xcoord[b] - xcoord[a]);
		if (area <= 0)
			System.err.println("Bogus input at line " +
			  fin.lineno() + 
			  ": Not convex or not counterclockwise");
		return area;
	}

	static int mindiff()
	{
		int totalArea = 0;
		int bestDiff = 10000 * 10000;
		int p, q, i;

		for (i = 2; i < n; i++)
			totalArea += triangle(0, i-1, i);

		for (p = 0; p < n; p++) {
			int area = 0;
			for (q = p + 2; q < n; q++) {
				area += triangle(p, q-1, q);
				int diff = Math.abs(totalArea - 2 * area);
				if (diff < bestDiff)
					bestDiff = diff;
			}
		}

		return bestDiff;
	}

	static public void main(String[] args)
	{
		int runs;

		try {

			fin = new StreamTokenizer(
			        new FileInputStream("convex.in"));
			fin.resetSyntax();
			fin.whitespaceChars(0, 0x20);
			fin.wordChars(0x21, 0xff);

			fin.nextToken();
			runs = Integer.parseInt(fin.sval);

			while ((runs--) > 0) {
				int d;
				readinp();
				d = mindiff();
				System.out.println((d / 2) + "." +
				                   ((d % 2 == 1) ? "5" : "0"));
			}

		} catch (IOException e) {
			System.out.println("Rhaaaa");
			System.out.println(e);
		}
	}

}

/* end */
