/*
 *  tegelen.c
 *  Joris van Rantwijk, Okt 1999
 *  TU Delft
 */

#include <stdlib.h>
#include <stdio.h>

#define MAXSIZE		100

FILE *fin;
int cost[MAXSIZE+1][MAXSIZE+1];


void read_tegels()
{
	int tegel;
	int i, j;

	for (i = 0; i <= MAXSIZE; i++)
		for (j = 0; j <= MAXSIZE; j++)
			cost[i][j] = 0;

	fscanf(fin, "%d", &tegel);
	while ((tegel--) > 0) {
		fscanf(fin, "%d %d", &i, &j);
		cost[i][j] = 1;
		cost[j][i] = 1;
	}
}


void solve()
{
	int i, j, k, min;

	for (i = 1; i <= MAXSIZE; i++)
	    for (j = 1; j <= MAXSIZE; j++)
		if (cost[i][j] == 0) {
			min = 10000;
			for (k = 1; k < i; k++)
				if (cost[k][j] + cost[i-k][j] < min)
					min = cost[k][j] + cost[i-k][j];
			for (k = 1; k < j; k++)
				if (cost[i][k] + cost[i][j-k] < min)
					min = cost[i][k] + cost[i][j-k];
			cost[i][j] = min;
		}
}


void do_vloeren()
{
	int v;
	fscanf(fin, "%d", &v);
	while ((v--) > 0) {
		int b, l;
		fscanf(fin, "%d %d", &b, &l);
		printf("%d", cost[b][l]);
		if (v > 0)
			printf(" ");
	}
	printf("\n");
}


int main(void)
{
	int run;

	fin = fopen("tegelen.in", "r");

	fscanf(fin, "%d", &run);
	
	while ((run--) > 0) {
		read_tegels();
		solve();
		do_vloeren();
	}

	return 0;
}

/* end */
